/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech) (5.1.0).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
package com.network.swagger.api;

import com.network.swagger.models.NetworkAddressDTO;
import io.swagger.annotations.*;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.context.request.NativeWebRequest;
import org.springframework.web.multipart.MultipartFile;
import springfox.documentation.annotations.ApiIgnore;

import javax.validation.Valid;
import javax.validation.constraints.*;
import java.util.List;
import java.util.Map;
import java.util.Optional;
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2021-10-03T00:55:00.527+01:00[Europe/London]")
@Validated
@Api(value = "network", description = "the network API")
public interface NetworkApi {

    default Optional<NativeWebRequest> getRequest() {
        return Optional.empty();
    }

    /**
     * GET /network/address/all : retrieves all IP/MAC addresses for devices on servers network.
     *
     * @return OK (status code 200)
     */
    @ApiOperation(value = "retrieves all IP/MAC addresses for devices on servers network.", nickname = "networkAddressAllGet", notes = "", response = NetworkAddressDTO.class, responseContainer = "List", tags={  })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "OK", response = NetworkAddressDTO.class, responseContainer = "List") })
    @GetMapping(
        value = "/network/address/all",
        produces = { "application/json" }
    )
    default ResponseEntity<List<NetworkAddressDTO>> networkAddressAllGet() {
        getRequest().ifPresent(request -> {
            for (MediaType mediaType: MediaType.parseMediaTypes(request.getHeader("Accept"))) {
                if (mediaType.isCompatibleWith(MediaType.valueOf("application/json"))) {
                    String exampleString = "{ \"ip\" : \"ip\", \"mac\" : \"mac\" }";
                    ApiUtil.setExampleResponse(request, "application/json", exampleString);
                    break;
                }
            }
        });
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }


    /**
     * GET /network/ipAddress/all : retrieves list of all IP addresses on servers network.
     *
     * @return OK (status code 200)
     */
    @ApiOperation(value = "retrieves list of all IP addresses on servers network.", nickname = "networkIpAddressAllGet", notes = "", response = String.class, responseContainer = "List", tags={  })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "OK", response = String.class, responseContainer = "List") })
    @GetMapping(
        value = "/network/ipAddress/all",
        produces = { "application/json" }
    )
    default ResponseEntity<List<String>> networkIpAddressAllGet() {
        getRequest().ifPresent(request -> {
            for (MediaType mediaType: MediaType.parseMediaTypes(request.getHeader("Accept"))) {
                if (mediaType.isCompatibleWith(MediaType.valueOf("application/json"))) {
                    String exampleString = "\"\"";
                    ApiUtil.setExampleResponse(request, "application/json", exampleString);
                    break;
                }
            }
        });
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }


    /**
     * GET /network/ipAddress/present : returns true/false depending on whether IP address is present on server&#39;s network.
     *
     * @param ipAddress IP Address must be in format 192.168.8.1 (required)
     * @return OK (status code 200)
     *         or Bad request, IP address must be in format 192.168.8.1 (status code 400)
     *         or Service unavailable. (status code 503)
     */
    @ApiOperation(value = "returns true/false depending on whether IP address is present on server's network.", nickname = "networkIpAddressPresentGet", notes = "", response = Boolean.class, tags={  })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "OK", response = Boolean.class),
        @ApiResponse(code = 400, message = "Bad request, IP address must be in format 192.168.8.1"),
        @ApiResponse(code = 503, message = "Service unavailable.") })
    @GetMapping(
        value = "/network/ipAddress/present",
        produces = { "application/json" }
    )
    default ResponseEntity<Boolean> networkIpAddressPresentGet(@NotNull @Pattern(regexp="^(?:[0-9]{1,3}\\.){3}[0-9]{1,3}$") @ApiParam(value = "IP Address must be in format 192.168.8.1", required = true) @Valid @RequestParam(value = "ipAddress", required = true) String ipAddress) {
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }


    /**
     * GET /network/macAddress/all : retrieves list of all MAC addresses on servers network.
     *
     * @return OK (status code 200)
     */
    @ApiOperation(value = "retrieves list of all MAC addresses on servers network.", nickname = "networkMacAddressAllGet", notes = "", response = String.class, responseContainer = "List", tags={  })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "OK", response = String.class, responseContainer = "List") })
    @GetMapping(
        value = "/network/macAddress/all",
        produces = { "application/json" }
    )
    default ResponseEntity<List<String>> networkMacAddressAllGet() {
        getRequest().ifPresent(request -> {
            for (MediaType mediaType: MediaType.parseMediaTypes(request.getHeader("Accept"))) {
                if (mediaType.isCompatibleWith(MediaType.valueOf("application/json"))) {
                    String exampleString = "\"\"";
                    ApiUtil.setExampleResponse(request, "application/json", exampleString);
                    break;
                }
            }
        });
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }


    /**
     * GET /network/macAddress/present : returns true/false depending on whether MAC address is present on server&#39;s network.
     *
     * @param macAddress MAC Address must be in format b8-27-eb-b0-79-ee (required)
     * @return OK (status code 200)
     *         or Bad request, MAC address must be in format b8-27-eb-b0-79-ee (status code 400)
     *         or Service unavailable. (status code 503)
     */
    @ApiOperation(value = "returns true/false depending on whether MAC address is present on server's network.", nickname = "networkMacAddressPresentGet", notes = "", response = Boolean.class, tags={  })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "OK", response = Boolean.class),
        @ApiResponse(code = 400, message = "Bad request, MAC address must be in format b8-27-eb-b0-79-ee"),
        @ApiResponse(code = 503, message = "Service unavailable.") })
    @GetMapping(
        value = "/network/macAddress/present",
        produces = { "application/json" }
    )
    default ResponseEntity<Boolean> networkMacAddressPresentGet(@NotNull @Pattern(regexp="^([0-9A-Fa-f]{2}[:-]){5}([0-9A-Fa-f]{2})$") @ApiParam(value = "MAC Address must be in format b8-27-eb-b0-79-ee", required = true) @Valid @RequestParam(value = "macAddress", required = true) String macAddress) {
        return new ResponseEntity<>(HttpStatus.NOT_IMPLEMENTED);

    }

}
